import ts from 'typescript';
import { Plugin } from 'vite';
import { ResolvedVitePluginAngularOptions } from '../../plugin/plugin-options.js';
interface EmitFileResult {
    code: string;
    map?: string;
    dependencies: readonly string[];
    hash?: Uint8Array;
}
type FileEmitter = (file: string) => Promise<EmitFileResult | undefined>;
export declare const ProductionPlugin: (options: ResolvedVitePluginAngularOptions) => Plugin[];
export declare function createFileEmitter(program: ts.BuilderProgram, transformers?: ts.CustomTransformers, onAfterEmit?: (sourceFile: ts.SourceFile) => void): FileEmitter;
export {};
